unit Unit2;

interface

uses
  Classes, SysUtils, IWAppForm, IWApplication, IWTypes, IWCompButton,
  IWCompMemo, IWCompEdit, IWCompListbox, IWCompCheckbox,
  IWCompLabel, IWControl, IWWebPlanner, Controls, IWVCLBaseControl,
  IWBaseControl, IWCompRectangle, IWColor, Graphics, IWBaseHTMLControl, Windows,
  pngimage, Forms, IWVCLBaseContainer, IWContainer, IWHTMLContainer,
  IWHTML40Container, IWRegion, jpeg
  {IW121}
  {Uncomment the line below when using IntraWeb 12.1 or higher}
  //, IWCompExtCtrls
  {Pre IW121}
  {Uncomment the line below when using IntraWeb 12.0 or lower}
  , IWExtCtrls
  ;

type
  TIWForm2 = class(TIWAppForm)
    IWRectangle1: TIWRectangle;
    TIWWebPlanner1: TTIWWebPlanner;
    IWLabel1: TIWLabel;
    IWCheckBox1: TIWCheckBox;
    IWRadioGroup1: TIWRadioGroup;
    IWLabel3: TIWLabel;
    IWCheckBox2: TIWCheckBox;
    IWComboBox1: TIWComboBox;
    IWLabel4: TIWLabel;
    IWLabel5: TIWLabel;
    IWComboBox2: TIWComboBox;
    IWLabel6: TIWLabel;
    IWComboBox3: TIWComboBox;
    IWLabel7: TIWLabel;
    IWComboBox4: TIWComboBox;
    IWLabel9: TIWLabel;
    IWLabel10: TIWLabel;
    IWLabel11: TIWLabel;
    IWLabel12: TIWLabel;
    IWComboBox5: TIWComboBox;
    IWEdit1: TIWEdit;
    IWMemo1: TIWMemo;
    IWLabel13: TIWLabel;
    IWComboBox6: TIWComboBox;
    IWLabel14: TIWLabel;
    IWComboBox7: TIWComboBox;
    IWCheckBox3: TIWCheckBox;
    IWCheckBox4: TIWCheckBox;
    IWCheckBox5: TIWCheckBox;
    IWComboBox8: TIWComboBox;
    IWLabel16: TIWLabel;
    IWRectangle2: TIWRectangle;
    IWButton1: TIWButton;
    IWButton2: TIWButton;
    IWLabel2: TIWLabel;
    IWRadioGroup2: TIWRadioGroup;
    IWCheckBox6: TIWCheckBox;
    IWLabel8: TIWLabel;
    IWComboBox9: TIWComboBox;
    IWCheckBox7: TIWCheckBox;
    IWRegion1: TIWRegion;
    IWLabel15: TIWLabel;
    IWLabel21: TIWLabel;
    IWLabel22: TIWLabel;
    IWLabel23: TIWLabel;
    IWRegion2: TIWRegion;
    IWLabel17: TIWLabel;
    IWLabel18: TIWLabel;
    IWLabel19: TIWLabel;
    IWLabel20: TIWLabel;
    IWImage1: TIWImage;
    IWLabel24: TIWLabel;
    IWImage2: TIWImage;
    procedure IWAppFormCreate(Sender: TObject);
    procedure IWButton2Click(Sender: TObject);
    procedure IWButton1Click(Sender: TObject);
    procedure TIWWebPlanner1ItemCreate(Sender: TObject; FromBegin, ToEnd,
      Position: Integer);
    procedure TIWWebPlanner1ItemDelete(Sender: TObject; Item: TPlannerItem);
    procedure TIWWebPlanner1AsyncItemClick(Sender: TObject;
      EventParams: TStringList; ItemIndex: Integer; Item: TPlannerItem);
    procedure TIWWebPlanner1AsyncHeaderClick(Sender: TObject;
      EventParams: TStringList; Index: Integer);
  public
  end;

implementation

{$R *.dfm}

procedure TIWForm2.IWAppFormCreate(Sender: TObject);
var
  BeginTime, EndTime, Part1, Part2, Temp, Count, i: Integer;
  TimeValue: string;
begin
  IWLabel12.Caption := 'Date: ' + DateToStr(Date);
  IWEdit1.Text := '';

  TIWWebPlanner1.MultiSelect := true;
  TIWWebPlanner1.SelectionColor := $998877;

  TIWWebPlanner1.DefaultItem.CaptionBkg := $DFFAFF;
  TIWWebPlanner1.DefaultItem.CaptionBkgTo := $5AD4FF;
  TIWWebPlanner1.DefaultItem.CaptionFont.Color := clWebBlack;

  TIWWebPlanner1.Header.Background := $FFDBBF;
  TIWWebPlanner1.Header.BackgroundTo := $FFF7EF;
  TIWWebPlanner1.Header.GradientDirection := gdVertical;

  TIWWebPlanner1.SideBar.Background := $FFDBBF;
  TIWWebPlanner1.SideBar.BackgroundTo := $FFF7EF;
  TIWWebPlanner1.SideBar.OccupiedColor := $5AD4FF;
  TIWWebPlanner1.SideBar.OccupiedColorTo := $71EFFF;
  TIWWebPlanner1.SideBar.GradientDirection := gdVertical;

  TIWWebPlanner1.Bands.ActivePrimary := $FAEADE;
  TIWWebPlanner1.Bands.ActiveSecondary := $EDD9C8;
  TIWWebPlanner1.Bands.NonActivePrimary := $F6F6F6;
  TIWWebPlanner1.Bands.NonActiveSecondary := $E9EEEE;
  TIWWebPlanner1.Bands.Show := true;

  TIWWebPlanner1.Display.DisplayUnit := 30;
  TIWWebPlanner1.Display.DisplayStart := 12;
  TIWWebPlanner1.Display.DisplayEnd := 36;
  TIWWebPlanner1.Display.ActiveStart := 4;
  TIWWebPlanner1.Display.ActiveEnd := 20;

  TIWWebPlanner1.Font.Color := $8B4146;
  TIWWebPlanner1.SideBar.Font.Color := $8B4146;
  TIWWebPlanner1.SideBar.OccupiedFont.Color := clWebBlack;
  TIWWebPlanner1.Header.Font.Color := $8B4146;

  with TIWWebPlanner1 do
  begin
    IWCheckBox1.Checked := Overlap;
    IWCheckBox2.Checked := Bands.Show;

    case SideBar.Position of
      spLeft:
        IWRadioGroup1.ItemIndex := 0;
      spRight:
        IWRadioGroup1.ItemIndex := 1;
      spLeftRight:
        IWRadioGroup1.ItemIndex := 2;
    end;

    case DefaultItem.CaptionType of
      ctNone:
        IWRadioGroup2.ItemIndex := 0;
      ctTime:
        IWRadioGroup2.ItemIndex := 1;
      ctText:
        IWRadioGroup2.ItemIndex := 2;
      ctTimeText:
        IWRadioGroup2.ItemIndex := 3;
    end;

    Count := 60 div Display.DisplayUnit;
    BeginTime := Display.DisplayStart div Count;
    EndTime := Display.DisplayEnd div Count;

    for Temp := BeginTime to EndTime - 1 do
    begin
      Part1 := Temp;
      Part2 := -Display.DisplayUnit;
      for i := 0 to Count - 1 do
      begin
        Part2 := Part2 + Display.DisplayUnit;
        if (Part1 = 24) then
          TimeValue := '00'
        else
          TimeValue := IntToStr(Part1);

        if (Part2 = 0) then
          TimeValue := TimeValue + ':00'
        else
          TimeValue := TimeValue + ':' + IntToStr(Part2);

        IWComboBox6.Items.Add(TimeValue);
        IWComboBox7.Items.Add(TimeValue);
      end;
    end;
  end;
  IWComboBox6.ItemIndex := -1;
  IWComboBox7.ItemIndex := -1;

  with TIWWebPlanner1.CreateItem do
  begin
    ItemPos := 1;
    ItemBegin := 15;
    ItemEnd := 17;
    InHeader := true;
    CaptionText := 'Header Item 1';
    Text.Text := 'This is a read only header item.';
    ReadOnly := true;
    Font.Color := clBtnShadow;
    Color := clinfobk;
    Font.Style := [];
  end;

  with TIWWebPlanner1.CreateItem do
  begin
    ItemPos := 0;
    ItemBegin := 4;
    ItemEnd := 8;
    InHeader := true;
    CaptionText := 'Header Item 2';
    Text.Text := 'This is a header item.';
  end;

  with TIWWebPlanner1.CreateItem do
  begin
    ItemPos := 1;
    ItemBegin := 10;
    ItemEnd := 14;
    CaptionText := 'Item 1';
    Text.Text := 'This is a background item. Overlapping is not allowed.';
    Background := true;
    Font.Color := clBlack;
    Font.Style := [fsBold];
    Color := $FFDBBF;
  end;

  with TIWWebPlanner1.CreateItem do
  begin
    ItemPos := 3;
    ItemBegin := 4;
    ItemEnd := 9;
    CaptionText := 'Item 2';
    Text.Text := 'This item has a fixed size.  Resizing is not allowed.';
    FixedSize := true;
    Font.Color := clBlack;
    Font.Style := [fsBold];
    Color := $5AD4FF;
  end;

  with TIWWebPlanner1.CreateItem do
  begin
    ItemPos := 0;
    ItemBegin := 14;
    ItemEnd := 20;
    CaptionText := 'Item 3';
    Text.Text :=
      'This item has a fixed column.  It cannot be moved to another doctor.';
    FixedPosition := true;
    Font.Color := clBlack;
    Font.Style := [fsItalic];
    Color := $F6F6F6;
  end;

  with TIWWebPlanner1.CreateItem do
  begin
    ItemPos := 2;
    ItemBegin := 13;
    ItemEnd := 19;
    CaptionText := 'Item 4';
    Text.Text :=
      'This item has a fixed position.  It cannot be moved or resized.';
    FixedPos := true;
    Font.Color := clBlack;
    Font.Style := [fsBold, fsItalic];
    Color := $E9EEEE;
  end;

  with TIWWebPlanner1.CreateItem do
  begin
    ItemPos := 3;
    ItemBegin := 15;
    ItemEnd := 24;
    CaptionText := 'Item 5';
    Text.Text := 'Item with overlapping.';
    Font.Color := clBlack;
    Font.Style := [fsItalic];
    Color := $F6F6F6;
  end;

  with TIWWebPlanner1.CreateItem do
  begin
    ItemPos := 3;
    ItemBegin := 13;
    ItemEnd := 17;
    CaptionText := 'Item 6';
    Text.Text := 'Item with overlapping.';
    Font.Color := clNavy;
    Font.Style := [fsBold];
    Color := clinfobk;
  end;

end;

procedure TIWForm2.IWButton2Click(Sender: TObject);
var
  Temp: string;
  i: Integer;
  ColorItem: TIWColor;
  OkToCreate: boolean;
  APlannerItem: TPlannerItem;
begin
  ColorItem := clNone;
  if (IWComboBox6.ItemIndex = -1) or (IWComboBox7.ItemIndex = -1) then
    WebApplication.ShowMessage(
      'You have to choose a begin and/or end of the item.')
  else
  begin
    if IWComboBox7.ItemIndex > IWComboBox6.ItemIndex then
    begin
      OkToCreate := true;
      if not(IWCheckBox1.Checked) and
        (TIWWebPlanner1.Items.HasItem(IWComboBox6.ItemIndex,
          IWComboBox7.ItemIndex, IWComboBox5.ItemIndex)) then
        OkToCreate := false;

      if OkToCreate then
      begin
        APlannerItem := TIWWebPlanner1.Items.FindBackground
          (IWComboBox6.ItemIndex, IWComboBox7.ItemIndex, IWComboBox5.ItemIndex);
        if (Assigned(APlannerItem)) and not(IWCheckBox6.Checked) then
          WebApplication.ShowMessage('A background item doesn' + #39 +
              't allow any other items at this position.', smAlert)
        else
        begin
          with TIWWebPlanner1.CreateItem do
          begin
            ItemPos := IWComboBox5.ItemIndex;
            ItemBegin := IWComboBox6.ItemIndex;
            ItemEnd := IWComboBox7.ItemIndex;
            CaptionText := IWEdit1.Text;
            Temp := '';
            for i := 1 to IWMemo1.Lines.Count do
            begin
              Temp := Temp + IWMemo1.Lines[i - 1];
            end;
            Text.Text := Temp;

            Background := IWCheckBox3.Checked;
            FixedSize := IWCheckBox4.Checked;
            FixedPosition := IWCheckBox5.Checked;
            InHeader := IWCheckBox6.Checked;

            case IWComboBox8.ItemIndex of
              0:
                ColorItem := clWhite;
              1:
                ColorItem := clYellow;
              2:
                ColorItem := clGreen;
              3:
                ColorItem := clBlue;
              4:
                ColorItem := clSilver;
              5:
                ColorItem := clRed;
              6:
                ColorItem := clHighlight;
              7:
                ColorItem := clinfobk;
            end;
            Color := ColorItem;

            case IWComboBox9.ItemIndex of
              0:
                ColorItem := clWhite;
              1:
                ColorItem := clYellow;
              2:
                ColorItem := clGreen;
              3:
                ColorItem := clBlue;
              4:
                ColorItem := clSilver;
              5:
                ColorItem := clRed;
              6:
                ColorItem := clHighlight;
              7:
                ColorItem := clinfobk;
            end;
            Font.Color := ColorItem;

            IWEdit1.Text := '';
            IWComboBox6.ItemIndex := -1;
            IWComboBox7.ItemIndex := -1;
            IWMemo1.Lines.Clear;
            IWCheckBox3.Checked := false;
            IWCheckBox4.Checked := false;
            IWCheckBox5.Checked := false;
            IWCheckBox6.Checked := false;
          end;
        end;
      end
      else
        WebApplication.ShowMessage('Overlapping of items is not allowed.',
          smAlert);
    end
    else
      WebApplication.ShowMessage('End of item before begin of item', smAlert);
  end;

end;

procedure TIWForm2.IWButton1Click(Sender: TObject);
var
  i: integer;
  Color: TIWColor;
begin
  if IWCheckBox7.Checked then
    TIWWebPlanner1.EditType := edPopup
  else
    TIWWebPlanner1.EditType := edInplace;

  Color := clNone;
  TIWWebPlanner1.Overlap := IWCheckBox1.Checked;
  TIWWebPlanner1.Bands.Show := IWCheckBox2.Checked;

  case IWRadioGroup1.ItemIndex of
    0:
      TIWWebPlanner1.SideBar.Position := spLeft;
    1:
      TIWWebPlanner1.SideBar.Position := spRight;
    2:
      TIWWebPlanner1.SideBar.Position := spLeftRight;
  end;

  case IWComboBox1.ItemIndex of
    0:
      Color := clWhite;
    1:
      Color := clYellow;
    2:
      Color := clGreen;
    3:
      Color := clBlue;
    4:
      Color := clSilver;
    5:
      Color := clRed;
  end;
  TIWWebPlanner1.Display.ColorActive := Color;

  case IWComboBox2.ItemIndex of
    0:
      Color := clWhite;
    1:
      Color := clYellow;
    2:
      Color := clGreen;
    3:
      Color := clBlue;
    4:
      Color := clSilver;
    5:
      Color := clRed;
  end;
  TIWWebPlanner1.Display.ColorNonActive := Color;

  case IWComboBox3.ItemIndex of
    0:
      Color := clWhite;
    1:
      Color := clYellow;
    2:
      Color := clGreen;
    3:
      Color := clBlue;
    4:
      Color := clSilver;
    5:
      Color := clRed;
  end;
  TIWWebPlanner1.SideBar.OccupiedColor := Color;

  case IWComboBox4.ItemIndex of
    0:
      Color := clWhite;
    1:
      Color := clYellow;
    2:
      Color := clGreen;
    3:
      Color := clBlue;
    4:
      Color := clSilver;
    5:
      Color := clRed;
    6:
      Color := clHighlight;
  end;
  TIWWebPlanner1.SelectionColor := Color;

  case IWRadioGroup2.ItemIndex of
    0:
    begin
      TIWWebPlanner1.DefaultItem.CaptionType := ctNone;
      for I := 0 to TIWWebPlanner1.Items.Count - 1 do
        TIWWebPlanner1.Items[i].CaptionType := ctNone;
    end;
    1:
    begin
      TIWWebPlanner1.DefaultItem.CaptionType := ctTime;
      for I := 0 to TIWWebPlanner1.Items.Count - 1 do
        TIWWebPlanner1.Items[i].CaptionType := ctTime;
    end;
    2:
    begin
      TIWWebPlanner1.DefaultItem.CaptionType := ctText;
      for I := 0 to TIWWebPlanner1.Items.Count - 1 do
        TIWWebPlanner1.Items[i].CaptionType := ctText;
    end;
    3:
    begin
      TIWWebPlanner1.DefaultItem.CaptionType := ctTimeText;
      for I := 0 to TIWWebPlanner1.Items.Count - 1 do
        TIWWebPlanner1.Items[i].CaptionType := ctTimeText;
    end;
  end;

end;

procedure TIWForm2.TIWWebPlanner1AsyncHeaderClick(Sender: TObject;
  EventParams: TStringList; Index: Integer);
begin
  IWLabel24.Width := 547;
  IWLabel24.Text := 'Async Events: Header column ' + IntToStr(Index) + ' clicked.';
end;

procedure TIWForm2.TIWWebPlanner1AsyncItemClick(Sender: TObject;
  EventParams: TStringList; ItemIndex: Integer; Item: TPlannerItem);
begin
  IWLabel24.Width := 547;
  IWLabel24.Text := 'Async Events: "' + Item.CaptionText + '" clicked.';
end;

procedure TIWForm2.TIWWebPlanner1ItemCreate(Sender: TObject; FromBegin, ToEnd,
  Position: Integer);
var
  MsgBackground: string;
  APlannerItem: TPlannerItem;
begin
  MsgBackground := 'A background item doesn' + #39 +
    't allow any other items at this position.';

  with TIWWebPlanner1 do
  begin
    APlannerItem := TIWWebPlanner1.Items.FindBackground
      (FromBegin, ToEnd, Position);
    if not Overlap then
    begin
      if not Items.HasItem(FromBegin, ToEnd, Position) then
      begin
        if Assigned(APlannerItem) then
          WebApplication.ShowMessage(MsgBackground, smAlert)
        else
          CreateItemAtSelection
      end
      else
        WebApplication.ShowMessage('Overlapping of items is not allowed.',
          smAlert);
    end
    else
    begin
      if Assigned(APlannerItem) then
        WebApplication.ShowMessage(MsgBackground, smAlert)
      else
        with CreateItemAtSelection do
        begin
          Text.Text := 'Item created.';

        end;
    end;
  end;

end;

procedure TIWForm2.TIWWebPlanner1ItemDelete
  (Sender: TObject; Item: TPlannerItem);
begin
  Item.Free;
end;

initialization

TIWForm2.SetAsMainForm;

end.
